>From e488bbd81b3bff2bb35444b4e653efa9e6a29aad Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Mon, 19 Mar 2012 22:01:12 -0400
Subject: [PATCH] Allow clones to specify master and replica ports and
 security options

Removed -clone_start_tls option and subsumed it into -replicationSecurity.
Refactored DatabasePanel parameter verification code to allow it to be
used in both update() and validate().  Added new parameters to pkisilent
and databasepanel.vm.   Fixed pkisilent deprecation errors.
---
 .../src/com/netscape/certsrv/util/HttpInput.java   |   42 ++---
 .../cms/servlet/csadmin/ConfigHSMLoginPanel.java   |    5 +-
 .../cms/servlet/csadmin/DatabasePanel.java         |  236 ++++++++++++--------
 .../src/com/netscape/pkisilent/ConfigureCA.java    |  122 ++++++-----
 .../src/com/netscape/pkisilent/ConfigureDRM.java   |  135 ++++++-----
 .../src/com/netscape/pkisilent/ConfigureOCSP.java  |  118 ++++------
 .../src/com/netscape/pkisilent/ConfigureRA.java    |   63 +++---
 .../src/com/netscape/pkisilent/ConfigureSubCA.java |  113 +++++-----
 .../src/com/netscape/pkisilent/ConfigureTKS.java   |  108 ++++-----
 .../src/com/netscape/pkisilent/ConfigureTPS.java   |   99 ++++-----
 .../shared/admin/console/config/databasepanel.vm   |   39 +++-
 11 files changed, 555 insertions(+), 525 deletions(-)

diff --git a/pki/base/common/src/com/netscape/certsrv/util/HttpInput.java b/pki/base/common/src/com/netscape/certsrv/util/HttpInput.java
index fba601b6c61c580c10556de345ce520d8b51f48a..ba5bfdb08e4e051051a8d4de2a06b711633b1845 100644
--- a/pki/base/common/src/com/netscape/certsrv/util/HttpInput.java
+++ b/pki/base/common/src/com/netscape/certsrv/util/HttpInput.java
@@ -86,8 +86,7 @@ public class HttpInput {
         return v;
     }
 
-    public static String getString(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getString(HttpServletRequest request, String name) {
         String val = request.getParameter(name);
         return val;
     }
@@ -102,8 +101,7 @@ public class HttpInput {
         return val;
     }
 
-    public static String getLdapDatabase(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getLdapDatabase(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
@@ -118,13 +116,11 @@ public class HttpInput {
         return v;
     }
 
-    public static String getUID(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getUID(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
-    public static String getPassword(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getPassword(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
@@ -199,48 +195,39 @@ public class HttpInput {
         return v;
     }
 
-    public static String getID(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getID(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
-    public static String getName(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getName(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
-    public static String getCertRequest(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getCertRequest(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
-    public static String getCertChain(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getCertChain(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
-    public static String getCert(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getCert(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
-    public static String getNickname(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getNickname(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
-    public static String getHostname(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getHostname(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
-    public static String getTokenName(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getTokenName(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
-    public static String getReplicationAgreementName(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getReplicationAgreementName(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
@@ -253,8 +240,7 @@ public class HttpInput {
         return v;
     }
 
-    public static String getDomainName(HttpServletRequest request, String name)
-            throws IOException {
+    public static String getDomainName(HttpServletRequest request, String name) {
         return getString(request, name);
     }
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/csadmin/ConfigHSMLoginPanel.java b/pki/base/common/src/com/netscape/cms/servlet/csadmin/ConfigHSMLoginPanel.java
index 92e2ee392f717748123d5bd610f5f2d67d07fb6b..7197a05117bdf30cf59454bf9452ecfe3c932b5c 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/csadmin/ConfigHSMLoginPanel.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/csadmin/ConfigHSMLoginPanel.java
@@ -97,10 +97,7 @@ public class ConfigHSMLoginPanel extends WizardPanelBase {
 
         // get token selected to be logged in
         String tokName = null;
-        try {
-            tokName = HttpInput.getTokenName(request, "SecToken");
-        } catch (IOException e) {
-        }
+        tokName = HttpInput.getTokenName(request, "SecToken"); 
 
         if (tokName != null) {
             CMS.debug("ConfigHSMLoginPanel: selected token name= " + tokName);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/csadmin/DatabasePanel.java b/pki/base/common/src/com/netscape/cms/servlet/csadmin/DatabasePanel.java
index d3b0e380ec14f49bf0b0ceb4daee54b776e8fe69..0880e951486cb8d5b267ea8c04dc3e891c3b9902 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/csadmin/DatabasePanel.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/csadmin/DatabasePanel.java
@@ -25,6 +25,7 @@ import java.io.IOException;
 import java.io.PrintStream;
 import java.util.ArrayList;
 import java.util.Enumeration;
+import java.util.HashMap;
 import java.util.Random;
 import java.util.StringTokenizer;
 
@@ -67,11 +68,7 @@ public class DatabasePanel extends WizardPanelBase {
     private static final String HOST = "localhost";
     private static final String CLONE_HOST = "Enter FQDN here";
     private static final String PORT = "389";
-    private static final String BASEDN = "o=netscapeCertificateServer";
     private static final String BINDDN = "cn=Directory Manager";
-    private static final String DATABASE = "csRoot";
-    private static final String MASTER_AGREEMENT = "masteragreement-";
-    private static final String CLONE_AGREEMENT = "cloneagreement-";
 
     private WizardServlet mServlet = null;
 
@@ -170,7 +167,10 @@ public class DatabasePanel extends WizardPanelBase {
         String database = null;
         String errorString = "";
         String secure = "false";
-        String cloneStartTLS = "false";
+        String masterReplicationPort = "";
+        String cloneReplicationPort = "";
+        String replicationSecurity = "";
+        
         try {
             @SuppressWarnings("unused")
             String s = cs.getString("preop.database.removeData"); // check whether it's first time
@@ -192,7 +192,9 @@ public class DatabasePanel extends WizardPanelBase {
                 binddn = cs.getString("internaldb.ldapauth.bindDN", "");
                 database = cs.getString("internaldb.database", "");
                 secure = cs.getString("internaldb.ldapconn.secureConn", "");
-                cloneStartTLS = cs.getString("internaldb.ldapconn.cloneStartTLS", "");
+                replicationSecurity = cs.getString("internaldb.ldapconn.replicationSecurity", "None");
+                masterReplicationPort = cs.getString("internaldb.ldapconn.masterReplicationPort", "");
+                cloneReplicationPort = cs.getString("internaldb.ldapconn.cloneReplicationPort", "");
                 errorString = cs.getString("preop.database.errorString", "");
             } catch (Exception e) {
                 CMS.debug("DatabasePanel display: " + e.toString());
@@ -247,7 +249,9 @@ public class DatabasePanel extends WizardPanelBase {
         context.put("bindpwd", bindpwd);
         context.put("database", database);
         context.put("secureConn", (secure.equals("true") ? "on" : "off"));
-        context.put("cloneStartTLS", (cloneStartTLS.equals("true") ? "on" : "off"));
+        context.put("masterReplicationPort", masterReplicationPort);
+        context.put("cloneReplicationPort", cloneReplicationPort);
+        context.put("replicationSecurity", replicationSecurity);        
         context.put("panel", "admin/console/config/databasepanel.vm");
         context.put("errorString", errorString);
     }
@@ -270,125 +274,127 @@ public class DatabasePanel extends WizardPanelBase {
     }
 
     /**
-     * Checks if the given parameters are valid.
+     * Parses and validates the parameters in the request.
      */
-    public void validate(HttpServletRequest request,
-            HttpServletResponse response,
-            Context context) throws IOException {
-
+    public void parseParameters(HttpServletRequest request,
+            HttpServletResponse response, Context context) throws IOException {
         IConfigStore cs = CMS.getConfigStore();
-        context.put("firsttime", "false");
+
+        String select = "";
         try {
-            @SuppressWarnings("unused")
-            String s = cs.getString("preop.database.removeData"); // check whether it's first time
+            select = cs.getString("preop.subsystem.select", "");
         } catch (Exception e) {
-            context.put("firsttime", "true");
         }
 
         String hostname = HttpInput.getHostname(request, "host");
+        if (hostname == null || hostname.length() == 0) {
+            throw new IOException("hostname is empty string");
+        }
         context.put("hostname", hostname);
 
+        // this validates that port is an integer
         String portStr = HttpInput.getPortNumber(request, "port");
         context.put("portStr", portStr);
 
         String basedn = HttpInput.getDN(request, "basedn");
+        if (basedn == null || basedn.length() == 0) {
+            throw new IOException("basedn is empty string");
+        }
         context.put("basedn", basedn);
 
         String binddn = HttpInput.getDN(request, "binddn");
+        if (binddn == null || binddn.length() == 0) {
+            throw new IOException("binddn is empty string");
+        }
         context.put("binddn", binddn);
 
         String database = HttpInput.getLdapDatabase(request, "database");
+        if (database == null || database.length() == 0) {
+            throw new IOException("Database is empty string");
+        }
         context.put("database", database);
 
         String bindpwd = HttpInput.getPassword(request, "__bindpwd");
+        if (bindpwd == null || bindpwd.length() == 0) {
+            throw new IOException("Bind password is empty string");
+        }
         context.put("bindpwd", bindpwd);
 
         String secure = HttpInput.getCheckbox(request, "secureConn");
         context.put("secureConn", secure);
 
-        String cloneStartTLS = HttpInput.getCheckbox(request, "cloneStartTLS");
-        context.put("cloneStartTLS", cloneStartTLS);
+        String masterReplicationPort = HttpInput.getString(request, "masterReplicationPort");
+        if (masterReplicationPort != null && masterReplicationPort.length() > 0) {
+            try {
+                Integer.parseInt(masterReplicationPort); // check for errors
+            } catch (NumberFormatException e) {
+                throw new IOException("Master replication port is invalid");
+            }
+        }
+        context.put("masterReplicationPort", masterReplicationPort);
 
-        String select = "";
-        try {
-            select = cs.getString("preop.subsystem.select", "");
-        } catch (Exception e) {
+        String cloneReplicationPort = HttpInput.getString(request, "cloneReplicationPort");
+        if (cloneReplicationPort != null && cloneReplicationPort.length() > 0) {
+            try {
+                Integer.parseInt(cloneReplicationPort); // check for errors
+            } catch (Exception e) {
+                throw new IOException("Clone replication port is invalid");
+            }
         }
+        context.put("cloneReplicationPort", cloneReplicationPort);
+
+        String replicationSecurity = HttpInput.getString(request, "replicationSecurity");
+        context.put("replicationSecurity", replicationSecurity);
 
         if (select.equals("clone")) {
             String masterhost = "";
             String masterport = "";
             String masterbasedn = "";
+            String realhostname = "";
             try {
                 masterhost = cs.getString("preop.internaldb.master.ldapconn.host", "");
                 masterport = cs.getString("preop.internaldb.master.ldapconn.port", "");
                 masterbasedn = cs.getString("preop.internaldb.master.basedn", "");
+                realhostname = cs.getString("machineName", "");
             } catch (Exception e) {
             }
 
-            //get the real host name
-            String realhostname = "";
-            if (hostname.equals("localhost")) {
-                try {
-                    realhostname = cs.getString("machineName", "");
-                } catch (Exception ee) {
-                }
-            }
             if (masterhost.equals(realhostname) && masterport.equals(portStr)) {
-                context.put("updateStatus", "validate-failure");
                 throw new IOException("Master and clone must not share the same internal database");
             }
 
             if (!masterbasedn.equals(basedn)) {
-                context.put("updateStatus", "validate-failure");
                 throw new IOException("Master and clone should have the same base DN");
             }
         }
 
-        if (hostname == null || hostname.length() == 0) {
-            cs.putString("preop.database.errorString", "Host is empty string");
-            context.put("updateStatus", "validate-failure");
-            throw new IOException("Host is empty string");
-        }
+        context.put("errorString", "");
+        cs.putString("preop.database.errorString", "");
+    }
+    
+    /**
+     * Checks if the given parameters are valid.
+     */
+    public void validate(HttpServletRequest request,
+            HttpServletResponse response,
+            Context context) throws IOException {
 
-        if (portStr != null && portStr.length() > 0) {
-            try {
-                Integer.parseInt(portStr); // check for errors
-            } catch (Exception e) {
-                cs.putString("preop.database.errorString", "Port is invalid");
-                context.put("updateStatus", "validate-failure");
-                throw new IOException("Port is invalid");
-            }
-        } else {
-            cs.putString("preop.database.errorString", "Port is empty string");
-            context.put("updateStatus", "validate-failure");
-            throw new IOException("Port is empty string");
+        IConfigStore cs = CMS.getConfigStore();
+        context.put("firsttime", "false");
+        try {
+            @SuppressWarnings("unused")
+            String s = cs.getString("preop.database.removeData"); // check whether it's first time
+        } catch (Exception e) {
+            context.put("firsttime", "true");
         }
-
-        if (basedn == null || basedn.length() == 0) {
-            cs.putString("preop.database.errorString", "Base DN is empty string");
-            context.put("updateStatus", "validate-failure");
-            throw new IOException("Base DN is empty string");
-        }
-
-        if (binddn == null || binddn.length() == 0) {
-            cs.putString("preop.database.errorString", "Bind DN is empty string");
-            context.put("updateStatus", "validate-failure");
-            throw new IOException("Bind DN is empty string");
-        }
-
-        if (database == null || database.length() == 0) {
-            cs.putString("preop.database.errorString",
-                    "Database is empty string");
-            context.put("updateStatus", "validate-failure");
-            throw new IOException("Database is empty string");
-        }
-
-        if (bindpwd == null || bindpwd.length() == 0) {
-            cs.putString("preop.database.errorString",
-                    "Bind password is empty string");
+        
+        try {
+            parseParameters(request, response, context);            
+        } catch (IOException e) {
+            context.put("errorString", e.getMessage());
+            cs.putString("preop.database.errorString", e.getMessage());
             context.put("updateStatus", "validate-failure");
-            throw new IOException("Bind password is empty string");
+            throw e;
         }
 
         context.put("errorString", "");
@@ -737,8 +743,6 @@ public class DatabasePanel extends WizardPanelBase {
         } else {
             // data will be replicated from the master to the clone
             // so clone does not need the data
-            //
-
             importLDIFS("preop.internaldb.schema.ldif", conn);
             importLDIFS("preop.internaldb.ldif", conn);
             importLDIFS("preop.internaldb.data_ldif", conn);
@@ -884,6 +888,7 @@ public class DatabasePanel extends WizardPanelBase {
             }
         }
     }
+    
 
     /**
      * Commit parameter changes
@@ -913,22 +918,54 @@ public class DatabasePanel extends WizardPanelBase {
         } catch (Exception e) {
         }
 
-        String hostname2 = HttpInput.getHostname(request, "host");
-        String portStr2 = HttpInput.getPortNumber(request, "port");
-        String database2 = HttpInput.getLdapDatabase(request, "database");
-        String basedn2 = HttpInput.getDN(request, "basedn");
-
+        try {
+            parseParameters(request, response, context);            
+        } catch (IOException e) {
+            context.put("errorString", e.getMessage());
+            cs.putString("preop.database.errorString", e.getMessage());
+            context.put("updateStatus", "validate-failure");
+            throw e;
+        }
+                
+        String hostname2 = (String) context.get("hostname");        
+        String portStr2 = (String) context.get("portStr");
+        String database2 = (String) context.get("database");
+        String basedn2 = (String) context.get("basedn");
+        String binddn = (String) context.get("binddn");
+        String secure = (String) context.get("secureConn");
+        String masterReplicationPortStr = (String) context.get("masterReplicationPort");
+        String cloneReplicationPortStr = (String) context.get("cloneReplicationPort");
+        
         cs.putString("internaldb.ldapconn.host", hostname2);
         cs.putString("internaldb.ldapconn.port", portStr2);
+        cs.putString("internaldb.database", database2);
         cs.putString("internaldb.basedn", basedn2);
-        String binddn = HttpInput.getDN(request, "binddn");
         cs.putString("internaldb.ldapauth.bindDN", binddn);
-        cs.putString("internaldb.database", database2);
-        String secure = HttpInput.getCheckbox(request, "secureConn");
         cs.putString("internaldb.ldapconn.secureConn", (secure.equals("on") ? "true" : "false"));
-        String cloneStartTLS = HttpInput.getCheckbox(request, "cloneStartTLS");
-        cs.putString("internaldb.ldapconn.cloneStartTLS", (cloneStartTLS.equals("on") ? "true" : "false"));
-
+        
+        int masterReplicationPort = 0;
+        if ((masterReplicationPortStr != null) && (masterReplicationPortStr.length()>0)) {
+            masterReplicationPort = Integer.parseInt(masterReplicationPortStr);
+            cs.putString("internaldb.ldapconn.masterReplicationPort", masterReplicationPortStr);
+        }
+        
+        int cloneReplicationPort = 0;
+        int port = Integer.parseInt(portStr2);
+        if ((cloneReplicationPortStr != null) && (cloneReplicationPortStr.length()> 0)) {
+            cloneReplicationPort = Integer.parseInt(cloneReplicationPortStr); 
+        } else {
+            cloneReplicationPort = port;  
+        }
+        cs.putString("internaldb.ldapconn.cloneReplicationPort", cloneReplicationPortStr);
+        
+        String replicationSecurity = HttpInput.getString(request, "replicationSecurity");
+        if ((cloneReplicationPort == port) && (secure.equals("true"))) {
+            replicationSecurity = "SSL";
+        } else if (replicationSecurity == null) {
+            replicationSecurity = "None";
+        }
+        cs.putString("internaldb.ldapconn.replicationSecurity", replicationSecurity);
+        
         String remove = HttpInput.getID(request, "removeData");
         if (isPanelDone() && (remove == null || remove.equals(""))) {
             /* if user submits the same data, they just want to skip 
@@ -1054,8 +1091,8 @@ public class DatabasePanel extends WizardPanelBase {
         // setup replication after indexes have been created
         if (select.equals("clone")) {
             CMS.debug("Start setting up replication.");
-            setupReplication(request, context, (secure.equals("on") ? "true" : "false"), (cloneStartTLS.equals("on")
-                    ? "true" : "false"));
+            setupReplication(request, context, (secure.equals("on") ? "true" : "false"), 
+                    replicationSecurity, masterReplicationPort, cloneReplicationPort);
             CMS.debug("Finish setting up replication.");
 
             try {
@@ -1084,7 +1121,9 @@ public class DatabasePanel extends WizardPanelBase {
     }
 
     private void setupReplication(HttpServletRequest request,
-                  Context context, String secure, String cloneStartTLS) throws IOException {
+                  Context context, String secure, String replicationSecurity, 
+                  int masterReplicationPort, int cloneReplicationPort)
+            throws IOException {
         IConfigStore cs = CMS.getConfigStore();
 
         String cstype = "";
@@ -1188,11 +1227,11 @@ public class DatabasePanel extends WizardPanelBase {
 
             createReplicationAgreement(replicadn, masterConn, masterAgreementName,
                     replica_hostname, replica_port, replica_replicationpwd, basedn, cloneBindUser, secure,
-                    cloneStartTLS);
+                    replicationSecurity, cloneReplicationPort);
 
             createReplicationAgreement(replicadn, replicaConn, cloneAgreementName,
                     master_hostname, master_port, master_replicationpwd, basedn, masterBindUser, secure,
-                    cloneStartTLS);
+                    replicationSecurity, masterReplicationPort);
 
             // initialize consumer
             initializeConsumer(replicadn, masterConn, masterAgreementName);
@@ -1353,7 +1392,8 @@ public class DatabasePanel extends WizardPanelBase {
 
     private void createReplicationAgreement(String replicadn,
             LDAPConnection conn, String name, String replicahost, int replicaport,
-            String replicapwd, String basedn, String bindUser, String secure, String cloneStartTLS)
+            String replicapwd, String basedn, String bindUser, String secure, String replicationSecurity,
+            int replicationPort)
             throws LDAPException {
         String dn = "cn=" + name + "," + replicadn;
         CMS.debug("DatabasePanel createReplicationAgreement: dn: " + dn);
@@ -1367,15 +1407,21 @@ public class DatabasePanel extends WizardPanelBase {
             attrs.add(new LDAPAttribute("cn", name));
             attrs.add(new LDAPAttribute("nsDS5ReplicaRoot", basedn));
             attrs.add(new LDAPAttribute("nsDS5ReplicaHost", replicahost));
-            attrs.add(new LDAPAttribute("nsDS5ReplicaPort", "" + replicaport));
+            
+            if (replicationPort > 0) {
+                attrs.add(new LDAPAttribute("nsDS5ReplicaPort", "" + replicationPort));
+            } else {
+                attrs.add(new LDAPAttribute("nsDS5ReplicaPort", "" + replicaport));
+            }
+            
             attrs.add(new LDAPAttribute("nsDS5ReplicaBindDN",
                     "cn=" + bindUser + ",ou=csusers,cn=config"));
             attrs.add(new LDAPAttribute("nsDS5ReplicaBindMethod", "Simple"));
             attrs.add(new LDAPAttribute("nsds5replicacredentials", replicapwd));
 
-            if (secure.equals("true")) {
+            if (replicationSecurity.equals("SSL")) {
                 attrs.add(new LDAPAttribute("nsDS5ReplicaTransportInfo", "SSL"));
-            } else if (cloneStartTLS.equals("true")) {
+            } else if (replicationSecurity.equals("TLS")) {
                 attrs.add(new LDAPAttribute("nsDS5ReplicaTransportInfo", "TLS"));
             }
 
